/* USER CODE BEGIN Header */
/**
 ******************************************************************************
 * @file           : main.c
 * @brief          : Main program body
 ******************************************************************************
 * @attention
 *
 * Copyright (c) 2025 STMicroelectronics.
 * All rights reserved.
 *
 * This software is licensed under terms that can be found in the LICENSE file
 * in the root directory of this software component.
 * If no LICENSE file comes with this software, it is provided AS-IS.
 *
 ******************************************************************************
 */
/* USER CODE END Header */
/* Includes ------------------------------------------------------------------*/
#include "main.h"
#include "adc.h"
#include "dma.h"
#include "i2c.h"
#include "tim.h"
#include "usart.h"
#include "gpio.h"

/* Private includes ----------------------------------------------------------*/
/* USER CODE BEGIN Includes */
#include "Inf_4G.h"
#include "stdio.h"
#include "driver.h"
#include "Irrigation.h"
#include "Ozone.h"
#include "wendu.h"
#include "HLW8032.h"
#include "EEPROM.h"
#include "energy_manager.h"
#include "electrode.h"
#include "paini.h"
/* USER CODE END Includes */

/* Private typedef -----------------------------------------------------------*/
/* USER CODE BEGIN PTD */

/* USER CODE END PTD */

/* Private define ------------------------------------------------------------*/
/* USER CODE BEGIN PD */

/* USER CODE END PD */

/* Private macro -------------------------------------------------------------*/
/* USER CODE BEGIN PM */

/* USER CODE END PM */

/* Private variables ---------------------------------------------------------*/

/* USER CODE BEGIN PV */
// 鍒濆鍖栦负0
uint8_t aRxBuffer;

uint8_t received_control = 0; // 娣诲姞涓€涓爣蹇楁潵琛ㄧず鏄惁鏀跺埌鎺у埗鍛戒护
volatile uint8_t mode_control_flag = 0;
#define READ_CONTROL_INTERVAL 100  // 鎺ユ敹鎺у埗鍛戒护鐨勯棿锟�?(ms)
#define DATA_UPLOAD_INTERVAL 10000 // 鏁版嵁涓婁紶鐨勯棿锟�?(ms)
#define CONTROL_PRIORITY_DELAY 500 // 鎺у埗鍛戒护澶勭悊鍚庡欢杩熶笂浼犵殑鏃堕棿(ms)

#define SECONDS_PER_MINUTE 60 // 60锟�? = 1鍒嗛挓
/* USER CODE END PV */

/* Private function prototypes -----------------------------------------------*/
void SystemClock_Config(void);
/* USER CODE BEGIN PFP */

/* USER CODE END PFP */

/* Private user code ---------------------------------------------------------*/
/* USER CODE BEGIN 0 */

/* USER CODE END 0 */

/**
  * @brief  The application entry point.
  * @retval int
  */
int main(void)
{

  /* USER CODE BEGIN 1 */

  /* USER CODE END 1 */

  /* MCU Configuration--------------------------------------------------------*/

  /* Reset of all peripherals, Initializes the Flash interface and the Systick. */
  HAL_Init();

  /* USER CODE BEGIN Init */

  /* USER CODE END Init */

  /* Configure the system clock */
  SystemClock_Config();

  /* USER CODE BEGIN SysInit */

  /* USER CODE END SysInit */

  /* Initialize all configured peripherals */
  MX_GPIO_Init();
  MX_DMA_Init();
  MX_USART1_UART_Init();
  MX_USART2_UART_Init();
  MX_TIM6_Init();
  MX_TIM2_Init();
  MX_TIM7_Init();
  MX_ADC3_Init();
  MX_UART4_Init();
  MX_I2C2_Init();
  MX_TIM3_Init();
  /* USER CODE BEGIN 2 */
  
  timer_1s_cnt = 0;
  timer_1min_cnt = 0;
  timer_1hour_cnt = 0;

  
  HAL_GPIO_WritePin(GPIOG, GPIO_PIN_4, GPIO_PIN_RESET);

  
  Apphl8032_Init();

  /* USER CODE END 2 */

  /* Infinite loop */
  /* USER CODE BEGIN WHILE */
 
 
  Inf_4G_Init();

  Inf_EC800_MQTT_Init();

  Device_Init();
                 
  
  Ozone_Init();

  printf("Initializing ozone control...\n");
  Ozone_Init();
  //Inf_AT24C02_Init();
  ozone_running = 0; 
  ozone_timer = 0;  
  Ozone_Control(0); 
  printf("Ozone initialized, waiting for remote control\n");

  //  printf("Starting timers...\n");
  HAL_TIM_Base_Start_IT(&htim6); 

  HAL_TIM_Base_Start_IT(&htim7); 
  HAL_TIM_Base_Start_IT(&htim2); 
  HAL_TIM_Base_Start_IT(&htim3); 
  

  while (1)
  {

   
    Inf_EC800_ReadData(); 

   
    Check_4G_Connection(); 

    
     switch(current_mode) {
       case MODE_DIRECT:
         Direct_Mode_Control();
         break;
       case MODE_IRRIGATION:
         Irrigation_Mode_Control();
       break;
       case MODE_FLUSH:
         Flush_Mode_Control();
         break;
       case MODE_SPECIAL:
         Special_Mode_Control();
         break;
       default:
    //     // ???????????????
         current_mode = MODE_DIRECT;
         break;
      }

    
     if (need_upload)
     {
       Upload_Device_Data();
       need_upload = 0; // 娓呴櫎涓婁紶鏍囧織
     }
   
    //  if(UART4_RX_STA & 0x8000)
    //  {
    //      Data_Processing();
    // }

   

    // Energy_Management();
    // Update_All_Status();
    HAL_Delay(10);
    // Control_WaterPump(1);
    // HAL_Delay(5000);
    // Control_WaterPump(0);
    // HAL_Delay(5000);
    /* USER CODE END WHILE */

    /* USER CODE BEGIN 3 */
  }
  /* USER CODE END 3 */
}

/**
  * @brief System Clock Configuration
  * @retval None
  */
void SystemClock_Config(void)
{
  RCC_OscInitTypeDef RCC_OscInitStruct = {0};
  RCC_ClkInitTypeDef RCC_ClkInitStruct = {0};

  /** Configure the main internal regulator output voltage
  */
  __HAL_RCC_PWR_CLK_ENABLE();
  __HAL_PWR_VOLTAGESCALING_CONFIG(PWR_REGULATOR_VOLTAGE_SCALE1);

  /** Initializes the RCC Oscillators according to the specified parameters
  * in the RCC_OscInitTypeDef structure.
  */
  RCC_OscInitStruct.OscillatorType = RCC_OSCILLATORTYPE_HSE;
  RCC_OscInitStruct.HSEState = RCC_HSE_ON;
  RCC_OscInitStruct.PLL.PLLState = RCC_PLL_ON;
  RCC_OscInitStruct.PLL.PLLSource = RCC_PLLSOURCE_HSE;
  RCC_OscInitStruct.PLL.PLLM = 8;
  RCC_OscInitStruct.PLL.PLLN = 144;
  RCC_OscInitStruct.PLL.PLLP = RCC_PLLP_DIV2;
  RCC_OscInitStruct.PLL.PLLQ = 4;
  if (HAL_RCC_OscConfig(&RCC_OscInitStruct) != HAL_OK)
  {
    Error_Handler();
  }

  /** Initializes the CPU, AHB and APB buses clocks
  */
  RCC_ClkInitStruct.ClockType = RCC_CLOCKTYPE_HCLK|RCC_CLOCKTYPE_SYSCLK
                              |RCC_CLOCKTYPE_PCLK1|RCC_CLOCKTYPE_PCLK2;
  RCC_ClkInitStruct.SYSCLKSource = RCC_SYSCLKSOURCE_PLLCLK;
  RCC_ClkInitStruct.AHBCLKDivider = RCC_SYSCLK_DIV1;
  RCC_ClkInitStruct.APB1CLKDivider = RCC_HCLK_DIV2;
  RCC_ClkInitStruct.APB2CLKDivider = RCC_HCLK_DIV1;

  if (HAL_RCC_ClockConfig(&RCC_ClkInitStruct, FLASH_LATENCY_2) != HAL_OK)
  {
    Error_Handler();
  }
}

/* USER CODE BEGIN 4 */

void HAL_TIM_PeriodElapsedCallback(TIM_HandleTypeDef *htim)
{

  if (htim->Instance == TIM6)
  {

    static uint16_t upload_counter = 0;
    upload_counter++;

    if (upload_counter >= 5000) // 5绉掑埌锟�?(1ms * 2000 = 2s)
    {
      upload_counter = 0; // 娓呴浂璁℃暟锟�?
      need_upload = 1;    // 璁剧疆涓婁紶鏍囧織
    }

    //  Check_Flow();
  }
  else if (htim->Instance == TIM2)
  {

  

 
    // pump_timer++;
    // fan_timer++;
   
    // if (current_mode == MODE_SPECIAL)
    // {
  
    //   special_phase_timer++;
    //   special_cycle_timer++;
    // }
    // ???????
    static uint32_t interrupt_count = 0;
        
    // ?????????????????
    if(time_just_modified)
    {
        interrupt_count++;
        if(interrupt_count >= 60) {  // ????????
            pump_timer = 0;
            time_just_modified = 0;
            interrupt_count = 0;
            printf("??????????????\n");
        }
        return;  // ????????????
    }
   // ?????????
   
    if(!timer_pause) 
    {  // ??????????
      pump_timer++;
      fan_timer++;
      if (current_mode == MODE_SPECIAL)
      {
          special_phase_timer++;
          special_cycle_timer++;
      }
    }

   
    Ozone_Control_Update();
  }
  else if (htim->Instance == TIM7)
  {

    // 鐭殏寤舵椂纭繚娓╁害鏇存柊瀹屾垚
    // Inf_EC800_PublishDeviceStatus(); // 鍐嶅彂閫佺姸锟�?
    if (++timer_1s_cnt >= 60)
    {
      timer_1s_cnt = 0;
      if (++timer_1min_cnt >= 60)
      {
        timer_1min_cnt = 0;
        timer_1hour_cnt++;
      }
      Dredge_Control(); 
    }
  }
  else if (htim->Instance == TIM3)
  {

    
  }
}

/* USER CODE END 4 */

/**
  * @brief  This function is executed in case of error occurrence.
  * @retval None
  */
void Error_Handler(void)
{
  /* USER CODE BEGIN Error_Handler_Debug */
  /* User can add his own implementation to report the HAL error return state */
  __disable_irq();
  while (1)
  {
  }
  /* USER CODE END Error_Handler_Debug */
}

#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(uint8_t *file, uint32_t line)
{
  /* USER CODE BEGIN 6 */
  /* User can add his own implementation to report the file name and line number,
     ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
  /* USER CODE END 6 */
}
#endif /* USE_FULL_ASSERT */
